package com.bureau.devicefingerprint.datacollectors

import android.content.Context
import com.bureau.devicefingerprint.tools.executeSafe
import com.google.android.gms.ads.identifier.AdvertisingIdClient
import kotlinx.coroutines.*

class AdvertisingProvider(private val context: Context, private val adInfo: AdvertisingIdClient = AdvertisingIdClient(context.applicationContext)) {

    suspend fun getAdvertisingId(): String =
        withContext(Dispatchers.IO) {
            // Connect with start(), disconnect with finish()
            return@withContext executeSafe({
                adInfo.start()
                val adIdInfo = adInfo.info
                adIdInfo.id ?: ""
            }, "")
        }
}
