package com.bureau.devicefingerprint.datacollectors

import android.content.Context
import android.content.pm.PackageManager
import android.content.pm.Signature
import android.os.Build
import com.bureau.devicefingerprint.tools.executeSafe

class AppSignaturesProvider(
    var context: Context
) {
    fun getSignatures(): Array<Signature>? {
        var sigs: Array<Signature>?
        return executeSafe({
            sigs = if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.P) {
                context.packageManager.getPackageInfo(context.packageName, PackageManager.GET_SIGNING_CERTIFICATES).signingInfo.signingCertificateHistory
            } else {
                context.packageManager
                    .getPackageInfo(context.packageName, PackageManager.GET_SIGNATURES).signatures
            }
            sigs
        }, emptyArray())
    }
}
