package com.bureau.devicefingerprint.datacollectors

import android.content.Context
import android.net.wifi.WifiManager
import com.bureau.devicefingerprint.tools.executeSafe

class EmulatorPropertiesProvider(var context: Context) {
    fun getEmulatorIP(): String {
        return executeSafe({
            val wifiManager = context.applicationContext.getSystemService(Context.WIFI_SERVICE) as WifiManager
            val wifiInfo = wifiManager.connectionInfo
            val ip = wifiInfo.ipAddress
            val ipString = String.format(
                "%d.%d.%d.%d",
                ip and 0xff,
                ip shr 8 and 0xff,
                ip shr 16 and 0xff,
                ip shr 24 and 0xff
            )
            ipString
        }, "")
    }
}
