package com.bureau.devicefingerprint.datacollectors

import android.app.ActivityManager
import com.bureau.devicefingerprint.tools.executeSafe

interface GpuInfoProvider {
    fun glesVersion(): String
}

internal class GpuInfoProviderImpl(
    private val activityManager: ActivityManager
) : GpuInfoProvider {
    override fun glesVersion(): String {
        return executeSafe({ activityManager.deviceConfigurationInfo.glEsVersion }, "")
    }
}
