package com.bureau.devicefingerprint.datacollectors

import android.content.Context
import com.bureau.devicefingerprint.tools.executeSafe

class InstallInfoProvider(var context: Context) {
    fun getIsPlayStoreInstall(): Boolean {
        return executeSafe({
            val validInstallers: List<String> =
                ArrayList(listOf("com.android.vending", "com.google.android.feedback"))

            // The package name of the app that has installed your app

            // The package name of the app that has installed your app
            val installer: String? =
                context.packageManager.getInstallerPackageName(context.packageName)

            // true if your app has been downloaded from Play Store

            // true if your app has been downloaded from Play Store
            installer != null && validInstallers.contains(installer)
        }, false)
    }
}
