package com.bureau.devicefingerprint.datacollectors

import android.content.Context
import android.content.pm.PackageManager

interface SocialEngineeringInfoProvider {
    fun getIsSocialEngineeringAppInstalled(): Boolean
}

class SocialEngineeringInfoProviderImpl(context: Context) : SocialEngineeringInfoProvider {

    private val packageManager: PackageManager = context.packageManager
    override fun getIsSocialEngineeringAppInstalled(): Boolean {
        return packageManager
            .getInstalledApplications(PackageManager.GET_META_DATA)
            .map { it.packageName }
            .any {
                it in SOCIAL_ENGINEERING_APP_PACKAGE_NAMES
            }
    }

    companion object {
        val SOCIAL_ENGINEERING_APP_PACKAGE_NAMES = listOf(
            "us.zoom.videomeetings",
            "com.google.android.apps.tachyon",
            "com.cisco.webex.meetings",
            "com.microsoft.teams",
            "com.teamviewer.blizz.market",
            "com.anydesk.anydeskandroid",
            "com.microsoft.rdc.androidx"
        )
    }
}
