package com.bureau.devicefingerprint.datacollectors

import com.bureau.devicefingerprint.tools.SystemPropertiesInvoker
import com.bureau.devicefingerprint.tools.SystemPropertiesInvoker.getSystemProperty
import com.bureau.devicefingerprint.tools.executeSafe

class SystemPropertiesProvider {
    fun getBootMode(): String {
        return executeSafe({
            getSystemProperty("ro.bootmode")
        }, "")
    }

    fun getMainKey(): Boolean {
        return executeSafe({
            getSystemProperty("qemu.hw.mainkeys") == "1"
        }, false)
    }

    fun getProps(): String {
        return executeSafe({
            getSystemProperty("init.svc.qemu-props")
        }, "")
    }

    fun getAttributeData(): String {
        return executeSafe({
            getSystemProperty("init.svc.qemud")
        }, "")
    }

    fun getKernelData(): Boolean {
        return executeSafe({
            getSystemProperty("ro.kernel.android.qemud") == "1"
        }, false)
    }

    fun getGLES(): Boolean {
        return executeSafe({
            getSystemProperty("ro.kernel.qemu.gles") == "1"
        }, false)
    }

    fun getSerialNo(): String {
        return executeSafe({
            getSystemProperty("ro.serialno")
        }, "")
    }

    fun getFakeCamera(): String {
        return executeSafe({
            getSystemProperty("qemu.sf.fake_camera")
        }, "")
    }

    fun getLCDDensity(): String {
        return executeSafe({
            getSystemProperty("qemu.sf.lcd_density")
        }, "")
    }

    fun getQEMU(): Boolean {
        return executeSafe({
            getSystemProperty("ro.kernel.qemu") == "1"
        }, false)
    }

    fun getSystemProperties(): List<String> {
        return executeSafe({ SystemPropertiesInvoker.getSystemProperties() }, listOf())
    }
}
