package com.bureau.devicefingerprint.datacollectors

import android.content.Context
import android.net.wifi.WifiManager
import com.bureau.devicefingerprint.tools.executeSafe

interface WifiInfoProvider {
    fun getSSID(): String
    fun getBSSID(): String
    fun getRSSI(): Int
}

class WifiInfoProviderImpl(context: Context) : WifiInfoProvider {
    private val wifiManager = context.applicationContext.getSystemService(Context.WIFI_SERVICE) as WifiManager
    private val wifiInfo = wifiManager.connectionInfo
    override fun getSSID(): String {
        return executeSafe({
            wifiInfo.ssid
        }, "")
    }

    override fun getBSSID(): String {
        return executeSafe({
            wifiInfo.bssid
        }, "")
    }

    override fun getRSSI(): Int {
        return executeSafe({
            wifiInfo.rssi
        }, -1)
    }
}
