package com.bureau.devicefingerprint.models.devicedataholder

data class DeviceDataHolder(
    var advertisingID_: String? = null,
    var androidId_: AndroidId? = null,
    var batteryInfo_: BatteryInfo? = null,
    var cameraInfo_: CameraInfo? = null,
    var codecInfo_: CodecInfo? = null,
    var cpuInfo_: CpuInfo? = null,
    var debuggerInfo_: DebuggerInfo? = null,
    var devicePersonalizationInfo_: DevicePersonalizationInfo? = null,
    var deviceSecurityInfo_: DeviceSecurityInfo? = null,
    var elapsedTime_: Long? = null,
    var emulatorInfo_: EmulatorInfo? = null,
    var encryptionStatus_: Int? = null,
    var fingerPrintSensorInfo_: FingerPrintSensorInfo? = null,
    var flow_: String? = null,
    var gpuInfo_: GpuInfo? = null,
    var gsfId_: GsfId? = null,
    var inputDevicesInfo_: InputDevicesInfo? = null,
    var keyStoreKey_: String? = null,
    var locationInfo_: LocationInfo? = null,
    var mediaDrmId_: MediaDrmId? = null,
    var memInfo_: MemInfo? = null,
    var ndkInfo_: NdkInfo? = null,
    var networkInfo_: NetworkInfo? = null,
    var osBuildInfo_: OsBuildInfo? = null,
    var packageManagerInfo_: PackageManagerInfo? = null,
    var sdkVersion_: String? = null,
    var sensorsInfo_: SensorsInfo? = null,
    var sessionId_: String? = null,
    var settingsInfo_: SettingsInfo? = null,
    var signaturesInfo_: SignaturesInfo? = null,
    var systemProperties_: SystemProperties? = null,
    var uniqueFileId_: String? = null,
    var userId_: String? = null,
    var webInfo_: WebInfo? = null,
    var wifiList_: List<String>? = null,
    var voiceCallMode_: Int? = null,
    var appDirectorypath_: String? = null,
    var realTimeDataInfo_: RealTimeDatHolder? = null,
    var pastRealTimeDataInfo_: PastRealTimeDatHolder? = null,
    var screenInfo_: ScreenInfoHolder? = null,
    var networkSessionId_: String? = null,
    var lastfactoryResetTime_: Long? = null,
    var telecomBaseStationInfo_: TelecomBaseStationInfo = TelecomBaseStationInfo(),
    var rawParameters: RawParameters? = null,
    var isHookingDetected: Boolean = false,
    var metaData: MetaData = MetaData(),
    var socialEngineeringInfo: SocialEngineeringInfo = SocialEngineeringInfo(),
    var wifiInfoParameters: WifiInfoParameters = WifiInfoParameters()
)

data class ScreenInfoHolder(
    var screenCount_: Int? = null,
    var drawableDensity_: Int? = null,
    var layoutSize_: String? = null,
    var layoutHeight_: Int? = null,
    var layoutWidth_: Int? = null
)

data class AndroidId(
    var id_: String? = null
)

data class BatteryInfo(
    var batteryCapacity_: String? = null,
    var batteryHealth_: String? = null,
    var isCharging_: Boolean? = null
)

data class CameraInfo(
    var cameraCoreInfo_: List<CameraCoreInfo>? = null
)

data class CodecInfo(
    var capabilities_: List<String>? = null,
    var name_: String? = null
)

data class CpuInfo(
    var abiType_: String? = null,
    var coreCount_: Int? = null,
    var cpuInfo_: HashMap<String, String>? = null
)

data class DebuggerInfo(
    var isDebuggerAttached_: Boolean? = null,
    var isRooted_: Boolean? = null
)

data class DevicePersonalizationInfo(
    var availableLocales_: List<String>? = null,
    var defaultLanguage_: String? = null,
    var regionOrCountry_: String? = null,
    var ringtoneSource_: String? = null,
    var timeZone_: String? = null
)

data class DeviceSecurityInfo(
    var encryptionStatus_: String? = null,
    var isPinEnabled_: Boolean? = null,
    var securityProviders_: HashMap<String, String>? = null
)

data class EmulatorInfo(
    var emulatorIp_: String? = null,
    var qEMUVendor_: String? = null
)

data class FingerPrintSensorInfo(
    var sensorStatus_: String? = null
)

data class GpuInfo(
    var glesVersion_: String? = null
)

data class GsfId(
    var gsfId_: String? = null
)

data class InputDevicesInfo(
    var inputDeviceData_: List<InputDeviceData>? = null
)

data class LocationInfo(
    var currentLocation_: CurrentLocation? = null,
    var isLocationEnabled_: Boolean? = null,
    var isLocationPermissionEnabled_: Boolean? = null,
    var isMockGPS_: Boolean? = null,
    var lastKnownLocation_: LastKnownLocation? = null
)

data class MediaDrmId(
    var drmId_: String? = null
)

data class MemInfo(
    var totalExternalStorageSpace_: Long? = null,
    var totalInternalStorageSpace_: Long? = null,
    var totalRAM_: Long? = null
)

data class NdkInfo(
    var applicationId_: String? = null,
    var installPath_: String? = null
)

data class NetworkInfo(
    var ethernetMACAddress_: String? = null,
    var iPV4_: String? = null,
    var iPV6_: String? = null,
    var isVpnConnected_: Boolean? = null,
    var wifiMacAddress_: String? = null,
    var isWifiConnected_: Boolean? = null,
    var isCellularConnected_: Boolean? = null

)

data class OsBuildInfo(
    var androidVersion_: String? = null,
    var fingerprint_: String? = null,
    var kernelVersion_: String? = null,
    var manufacturerName_: String? = null,
    var modelName_: String? = null,
    var sdkVersion_: String? = null,
    var board_: String? = null,
    var device_: String? = null,
    var host_: String? = null,
    var product_: String? = null,
    var brand_: String? = null
)

data class PackageManagerInfo(
    var isPackageDebuggable_: Boolean? = null,
    var packageVersion_: String? = null,
    var systemApplicationList_: List<SystemApplication>? = null,
    var userApplicationList_: List<UserApplication>? = null
)

data class SensorsInfo(
    var sensorData_: List<SensorData>? = null
)

data class SettingsInfo(
    var accessibilityEnabled_: String? = null,
    var adbEnabled_: String? = null,
    var alarmAlertPath_: String? = null,
    var dataRoamingEnabled_: String? = null,
    var dateFormat_: String? = null,
    var defaultInputMethod_: String? = null,
    var developmentSettingsEnabled_: String? = null,
    var endButtonBehaviour_: String? = null,
    var fontScale_: String? = null,
    var httpProxy_: String? = null,
    var rttCallingMode_: String? = null,
    var screenOffTimeout_: String? = null,
    var textAutoPunctuate_: String? = null,
    var textAutoReplaceEnable_: String? = null,
    var touchExplorationEnabled_: String? = null,
    var transitionAnimationScale_: String? = null,
    var windowAnimationScale_: String? = null
)

data class SignaturesInfo(
    var isPlayStoreInstall_: Boolean? = null,
    var signatureHashcode_: List<String>? = null
)

data class SystemProperties(
    var attributeData_: String? = null,
    var bootMode_: String? = null,
    var density_: String? = null,
    var deviceProps_: String? = null,
    var fakeCamera_: String? = null,
    var kernelGlESEnabled_: Boolean? = null,
    var kernelVMRunning_: Boolean? = null,
    var mainKeyEnabled_: Boolean? = null,
    var serialNo_: String? = null,
    var kernelQEMUEnabled_: Boolean? = null,
    var systemProperties: List<String> = listOf()
)

data class WebInfo(
    var userAgent_: String? = null
)

data class CameraCoreInfo(
    var cameraName_: String? = null,
    var cameraOrientation_: String? = null,
    var cameraType_: String? = null
)

/*data class CpuInfoX(
    var addresssizes: String?,
    var apicid: String?,
    var bogomips: String?,
    var bugs: String?,
    var cachesize: String?,
    var cache_alignment: String?,
    var clflushsize: String?,
    var coreid: String?,
    var cpuMHz: String?,
    var cpucores: String?,
    var cpufamily: String?,
    var cpuidlevel: String?,
    var flags: String?,
    var fpu: String?,
    var fpu_exception: String?,
    var initialapicid: String?,
    var microcode: String?,
    var model: String?,
    var modelname: String?,
    var physicalid: String?,
    var processor: String?,
    var siblings: String?,
    var stepping: String?,
    var vendor_id: String?,
    var wp: String?
)

data class SecurityProviders(
    var AndroidKeyStore: String?,
    var AndroidKeyStoreBCWorkaround: String?,
    var AndroidNSSP: String?,
    var AndroidOpenSSL: String?,
    var BC: String?,
    var CertPathProvider: String?,
    var HarmonyJSSE: String?
)*/

data class InputDeviceData(
    var name_: String? = null,
    var vendor_: String? = null
)

data class CurrentLocation(
    var city_: String? = null,
    var latitude_: String? = null,
    var longitude_: String? = null,
    var gpsPrecision_: Float? = null,
    var country_: String? = null,
    var region_: String? = null
)

data class LastKnownLocation(
    var city_: String? = null,
    var latitude_: String? = null,
    var longitude_: String? = null,
    var gpsPrecision_: Float? = null,
    var country_: String? = null,
    var region_: String? = null
)

data class SystemApplication(
    var packageName_: String? = null
)

data class UserApplication(
    var packageName_: String? = null
)

data class SensorData(
    var sensorName_: String? = null,
    var sensorVendorName_: String? = null
)

data class RealTimeDatHolder(
    var vpnStatus_: Boolean? = null,
    var mockGPSStatus_: Boolean? = null,
    var debuggerStatus_: Boolean? = null
)

data class PastRealTimeDatHolder(
    var pastVpnStatus_: Boolean? = null,
    var pastMockGPSStatus_: Boolean? = null,
    var pastDebuggerStatus_: Boolean? = null
)

data class TelecomBaseStationInfo(
    val type: String = "",
    val mcc_: String = "",
    val mnc_: String = "",
    val lac_: String = "",
    val cid_: String = ""
)

data class RawParameters(
    var isMuted: Boolean,
    var volumeLevel: Int,
    var batteryLevel: Int,
    var batteryTemperatureInCentigrade: Float,
    var batteryVoltage: Int,
    var buildId: String,
    val buildTime: String,
    var freeInternalStorageSpace: Long,
    var freeExternalStorageSpace: Long,
    var pasteBoardString: String,
    var brightness: Int
)

data class WifiInfoParameters(
    val SSID: String = "",
    val BSSID: String = "",
    val RSSI: Int = -1
)

data class MetaData(
    val gpsEnabled: Boolean = false,
    var networkEnabled: Boolean = false
)

data class SocialEngineeringInfo(
    val isSocialEngineeringAppInstalled: Boolean = false
)
