package com.bureau.devicefingerprint.tools

import android.app.ActivityManager
import android.content.Context
import android.os.Environment
import android.os.StatFs
import com.bureau.devicefingerprint.datacollectors.MemInfoProvider
import com.bureau.devicefingerprint.datacollectors.MemInfoProviderImpl

object DependencyHelpers {

    fun createMemoryInfoProvider(context: Context): MemInfoProvider {
        val activityManager = context.getSystemService(Context.ACTIVITY_SERVICE) as ActivityManager
        val internalStorageDir = Environment.getRootDirectory().absolutePath
        val internalStorageStatFs = StatFs(internalStorageDir)

        val externalStorageDir = context.getExternalFilesDir(null)?.absolutePath
        val externalStorageStatFs =
            if (externalStorageDir != null) StatFs(externalStorageDir) else null

        return MemInfoProviderImpl(
            activityManager,
            internalStorageStatFs,
            externalStorageStatFs
        )
    }
}
