package com.bureau.devicefingerprint.tools

import com.bureau.devicefingerprint.BureauAPI
import java.lang.Exception

fun <T> executeSafe(code: () -> T, defaultValue: T): T {
    return try {
        code()
    } catch (exception: Exception) {
        BureauAPI.handleException(exception)
        defaultValue
    }
}
