package com.bureau.devicefingerprint.tools

import android.content.Context

object SharedPreferenceHelper {
    private const val PREF_FILE_REAL_TIME_DATA = "BUREAU_DEVICE_INTELLIGENCE_REAL_TIME_DATA"
    private const val PREF_FILE_MOONSENSE = "BUREAU_DEVICE_INTELLIGENCE_MOONSENSE"

    const val isPastVPNData = "isPastVPNData"
    const val isPastMockGPSData = "isPastMockGPSData"
    const val isPastDebuggerData = "isPastDebuggerData"

    internal fun setSharedPreferenceBoolean(context: Context, key: String, value: Boolean, isDataMonitoring: Boolean) {
        val settings = if (isDataMonitoring) {
            context.getSharedPreferences(PREF_FILE_REAL_TIME_DATA, 0)
        } else {
            context.getSharedPreferences(PREF_FILE_MOONSENSE, 0)
        }
        val editor = settings.edit()
        editor.putBoolean(key, value)
        editor.apply()
    }

    internal fun getSharedPreferenceBoolean(
        context: Context,
        key: String,
        defValue: Boolean,
        isDataMonitoring: Boolean
    ): Boolean {
        val settings = if (isDataMonitoring) {
            context.getSharedPreferences(PREF_FILE_REAL_TIME_DATA, 0)
        } else {
            context.getSharedPreferences(PREF_FILE_MOONSENSE, 0)
        }
        return settings.getBoolean(key, defValue)
    }

    internal fun clearAllDataPref(context: Context) {
        val settings = context.getSharedPreferences(PREF_FILE_REAL_TIME_DATA, 0)
        val editor = settings.edit()
        editor.clear()
        editor.apply()
    }

    internal fun clearSpecificDataPref(context: Context, key: String) {
        val settings = context.getSharedPreferences(PREF_FILE_REAL_TIME_DATA, 0)
        val editor = settings.edit()
        editor.remove(key)
        editor.apply()
    }
}
