package com.bureau.devicefingerprint.usecases

import android.content.Context
import com.bureau.devicefingerprint.models.EncryptedDeviceData
import com.bureau.devicefingerprint.models.devicedataholder.DeviceDataHolder

class GetEncryptedDeviceDataUseCase(private val context: Context) {
    operator fun invoke(deviceDataHolder: DeviceDataHolder?): EncryptedDeviceData {
        val deviceDataEncryptionUseCase = DeviceDataEncryptionUseCase(context = context)
        deviceDataEncryptionUseCase.initKeys()

        return EncryptedDeviceData(
            payload = deviceDataEncryptionUseCase.getEncryptedPayload(deviceDataHolder),
            eaKey = deviceDataEncryptionUseCase.getRSAEncryptedString(deviceDataEncryptionUseCase.passPhrase),
            eaIV = deviceDataEncryptionUseCase.getRSAEncryptedString(deviceDataEncryptionUseCase.ivGlobal)
        )
    }
}
